image: registry.gitlab.com/irelo/development/docker/php:7.3

cache:
  paths:
  - vendor/

before_script:
  - git clone --depth 1 https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/irelo/devops/falcon.git

stages:
 - qa
 - build
 - deploy
 - post_deploy

test:
  stage: qa
  script: /bin/bash falcon/php/laravel/test.sh

build:
  stage: build
  script: /bin/bash falcon/php/laravel/build.sh
  artifacts:
    name: "$CI_PROJECT_NAME-$CI_COMMIT_SHA"
    paths:
     - "$CI_PROJECT_NAME-$CI_COMMIT_SHA.tgz"
    expire_in: 8 hours
  only:
  - master

deploy:
  stage: deploy
  image: python:3.6-stretch
  script: /bin/bash falcon/aws/upload_code.sh
  only:
   - master

code_quality:
  stage: post_deploy
  image: docker:stable
  before_script:
    - date
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run
        --env SOURCE_CODE="$PWD"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock
        "registry.gitlab.com/gitlab-org/security-products/codequality:$SP_VERSION" /code
  artifacts:
    paths: [gl-code-quality-report.json]
